
#property copyright "http://www.forex-tsd.com/"
#property link      "http://www.forex-tsd.com/"

//
//
//
//
//

#import "kernel32.dll"
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import

//
//
//
//
//

#define TIME_ZONE_ID_UNKNOWN   0
#define TIME_ZONE_ID_STANDARD  1
#define TIME_ZONE_ID_DAYLIGHT  2

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string ExpertName              = "Double Heiken Ashi Ea";
extern string Version                 = "v1";

extern string _gen                    = "General Settings";
extern bool   EcnBroker               = true;
extern bool   UseAutoMagic            = true;
extern int    ManualMagic             = 56564665;  
extern double lStopLoss               = 100;
extern double sStopLoss               = 100;
extern double lTakeProfit             = 300;
extern double sTakeProfit             = 300;
extern double lTrailingStop           = 35;
extern double sTrailingStop           = 35;
extern double BreakEven               = 0;
extern int    LockInPips              = 0;        // Profit Lock in pips
extern bool   TrailAfterBreakEvenOnly = false;
extern int    Slippage                = 4;
extern double Lots                    = 0.1;
extern double MaximumRisk             = 0;
extern double DecreaseFactor          = 3;
extern bool   CloseOnTrendChange      = false;
extern bool   SpreadProtection        = false;   // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int    PipTolerance            = 5;       // value in pips over normal spread to activate the SpreadProtection.

extern string XX                      = "Indicators";  
extern string _fha                    = "Fast Heiken Ashi Settings";
extern int    FastMaPeriod            = 21;
extern int    FastMaMetod             = 1;
extern int    FastStep                = 1;
extern bool   FastBetterFormula       = false;

extern string _sha                    = "Slow Heiken Ashi Settings";
extern int    SlowMaPeriod            = 50;
extern int    SlowMaMetod             = 1;
extern int    SlowStep                = 1;
extern bool   SlowBetterFormula       = false;
extern int    haBar                   = 1;

extern string trh				           = "Trading hours";
extern string tr1			              = "tradingHours is a comma delimited list";
extern string tr1a                    = "of start and stop times";
extern string tr2				           = "Prefix start with +, stop with -";
extern string tr2a                    = "Use 24H format, local time.";
extern string tr3				           = "Example: +07.00,-10.30,+14.15,-16.00";
extern string tr3a			           = "Do not leave spaces";
extern string tr4				           = "Blank input means 24 hour trading.";
extern string tradingHours            = "";

extern string __                      = "Setting for friday positions close";
extern bool   CloseOnFriday           = false;
extern int    FridayCloseHour         = 21; 
extern int    FridayCloseMinute       = 59; 

extern string os                      = "Other Stuff";
extern bool   ShowComments            = true;
extern bool   ShowAlerts              = false;
extern color  clOpenBuy               = Blue;
extern color  clCloseBuy              = Aqua;
extern color  clOpenSell              = Red;
extern color  clCloseSell             = Violet;

//
//
//
//
//

double   pipMultiplier = 1;
double   pPoint;
double   Spread,WorstSpread,NormalSpread;

string   tradingHoursDisplay;
string   s_symbol;

int      MAGIC;
int      digit;
int      TZInfoArray[43];
int 	   tradeHours[];
int      DontContinue;
int      openedOrders = 0;

bool     TradeTimeOk;

//
//
//
//
//

int init() 
{
   s_symbol = Symbol();
   pPoint   = MarketInfo(s_symbol,MODE_POINT);
   digit    = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
   
   //
   //
   //
   //
   //
   
   if (UseAutoMagic) MAGIC = GetMagic();
   else              MAGIC = ManualMagic;    
   
   //
   //
   //
   //
   //
   
   tradingHoursDisplay = tradingHours;
   initTradingHours(); 
   TradeTimeOk         = CheckTradingTimes();  
              
return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (!IsDllsAllowed()) 
   {
     Alert("DLLs are disabled.  To enable  check the box in the tools/options/expert advisors on your chart");
     return;
   }
   
   //
   //
   //
   //
   //
   
   TradeTimeOk = CheckTradingTimes();
   if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
   {
     if (TimeHour(TimeCurrent()) > FridayCloseHour ||
        (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
     {
       for(int i=OrdersTotal()-1; i>=0; i--)
  	    { 
     	   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     != s_symbol)    continue;
            if(OrderMagicNumber()!= MAGIC)       continue;

            if(OrderType()==OP_BUY)  { OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_ASK),0,CLR_NONE); continue; }
            if(OrderType()==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_BID),0,CLR_NONE); continue; }
       }
       return(0);
     }
   }
   
   //
   //
   //
   //
   //
   
   Spread = MarketInfo(s_symbol,MODE_SPREAD)/pipMultiplier;
   if (Spread>WorstSpread) WorstSpread=Spread;
   if (SpreadProtection && Spread>NormalSpread+PipTolerance) DontContinue=1; else DontContinue=0;
   
   //
   //
   //
   //
   //
   
   for (i=OrdersTotal()-1; i>=0; i--)
   { 
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
         if (OrderSymbol()      != s_symbol) continue;
         if (OrderMagicNumber() != MAGIC)    continue;
           openedOrders++;
   }
   
   //
   //
   //
   //
   //
   
   if (openedOrders == 0 && TradeTimeOk && DontContinue == 0)
   {
     double fasttrendNow = iCustom(s_symbol,0,"Heiken_Ashi_Smoothed_v1",FastMaPeriod,FastMaMetod,FastStep,FastBetterFormula,4,haBar);
     double fasttrendPre = iCustom(s_symbol,0,"Heiken_Ashi_Smoothed_v1",FastMaPeriod,FastMaMetod,FastStep,FastBetterFormula,4,haBar+1);
     double slowtrendNow = iCustom(s_symbol,0,"Heiken_Ashi_Smoothed_v1",SlowMaPeriod,SlowMaMetod,SlowStep,SlowBetterFormula,4,haBar);
     double slowtrendPre = iCustom(s_symbol,0,"Heiken_Ashi_Smoothed_v1",SlowMaPeriod,SlowMaMetod,SlowStep,SlowBetterFormula,4,haBar+1);
     
     if (slowtrendNow>0 && fasttrendNow>0 && fasttrendPre<0)
     {
        OpenBuy();
        return(0);
     }
     
     if (slowtrendNow<0 && fasttrendNow<0 && fasttrendPre>0)
     {
        OpenSell();
        return(0);
     }
  }
  
  if (BreakEven>0)        breakEvenManager();
  if (lTrailingStop > 0)  TrailingPositionsBuy();
  if (sTrailingStop > 0)  TrailingPositionsSell();
  if (CloseOnTrendChange) CheckForClose();
  if (ShowComments)       ChartComment();  
  
return (0);
}

//
//
//
//
//

void breakEvenManager() 
{
   double pAsk = Ask; 
   double pBid = Bid; 
   for(int i=OrdersTotal()-1; i>=0; i--)
  	{ 
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()     != s_symbol) continue;
      if(OrderMagicNumber()!= MAGIC)    continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType()==OP_BUY)
      {
        if (pBid-OrderOpenPrice()>pPoint*BreakEven*pipMultiplier) 
        {
          double BuyStop = OrderOpenPrice()+LockInPips*pPoint*pipMultiplier;
          if (OrderStopLoss() < BuyStop) 
          OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(BuyStop,digit),NormalizeDouble(OrderTakeProfit(),digit),LightGreen);
		    return;
	     }
      }
      
      //
      //
      //
      //
      //
      
      if (OrderType()==OP_SELL)
      {
        if (OrderOpenPrice()-pAsk > pPoint*BreakEven*pipMultiplier) 
        {
           double SellStop = OrderOpenPrice()-LockInPips*pPoint*pipMultiplier;
           if (OrderStopLoss() > SellStop) 
           OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(SellStop,digit),NormalizeDouble(OrderTakeProfit(),digit),DarkOrange);
		     return;
        }
      }   
   }
}   

//
//
//
//
//

void TrailingPositionsBuy() { 
   double pBid = Bid; 
   for (int i = OrdersTotal()-1; i >=0 ; i--) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
              if (TrailAfterBreakEvenOnly) { if(OrderStopLoss()<OrderOpenPrice()) return(0); }
                if (pBid - OrderOpenPrice()   > lTrailingStop * pPoint * pipMultiplier) { 
                  if (OrderStopLoss() < pBid  - lTrailingStop * pPoint * pipMultiplier) 
                      ModifyStopLoss(   pBid  - lTrailingStop * pPoint * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   double pAsk = Ask; 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
              if (TrailAfterBreakEvenOnly) { if(OrderStopLoss()>OrderOpenPrice()) return(0); }
                if (OrderOpenPrice()  - pAsk > sTrailingStop * pPoint * pipMultiplier) { 
                  if (OrderStopLoss() > pAsk + sTrailingStop * pPoint * pipMultiplier || OrderStopLoss() == 0)  
                      ModifyStopLoss(   pAsk + sTrailingStop * pPoint * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   double minStop = 0;
   double pBid    = Bid;
   double pAsk    = Ask;
   double sl      = MarketInfo(s_symbol,MODE_STOPLEVEL);   
   bool   canGo   = false;
      if (OrderType()==OP_BUY)
            { minStop = pBid-sl*pPoint; canGo = ldStopLoss<=minStop; }
      else  { minStop = pAsk+sl*pPoint; canGo = ldStopLoss>=minStop; }
      if (canGo)
      {
        fm = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(ldStopLoss,digit),NormalizeDouble(OrderTakeProfit(),digit),0,CLR_NONE); 
        if (fm == false)
        {
	        int    ErrorCode = GetLastError();
	        string ErrDesc   = ErrorDescription(ErrorCode);
	        string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
   	        if (ShowAlerts   == true) Alert(ErrAlert);
            	  string ErrLog = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
      	  Print(ErrLog);
      	}
      }      	
      else Print("Stop loss to close to current price");

}  

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = 0; if (lStopLoss>0)   lbStop = NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)-lStopLoss  *pPoint*pipMultiplier,digit);
   double lbTake = 0; if (lTakeProfit>0) lbTake = NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)+lTakeProfit*pPoint*pipMultiplier,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (openedOrders == 0)
   {
     if(!EcnBroker) 
          OrderSend(s_symbol,OP_BUY,LotsOptimized(sStopLoss),MarketInfo(s_symbol,MODE_ASK),Slippage*pipMultiplier,lbStop,lbTake,ExpertName,MAGIC,0,clOpenBuy); 
     else
     {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(sStopLoss),MarketInfo(s_symbol,MODE_ASK),Slippage*pipMultiplier,0,0,ExpertName,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Bid: ",MarketInfo(s_symbol,MODE_BID)," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       
  }
}

//
//
//
//
//

void OpenSell() 
{ 

   double lsStop = 0; if (sStopLoss>0)   lsStop = NormalizeDouble(MarketInfo(s_symbol,MODE_BID)+sStopLoss  *pPoint*pipMultiplier,digit);
   double lsTake = 0; if (sTakeProfit>0) lsTake = NormalizeDouble(MarketInfo(s_symbol,MODE_BID)-sTakeProfit*pPoint*pipMultiplier,digit);
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (openedOrders == 0)
   {
     if(!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(sStopLoss),MarketInfo(s_symbol,MODE_BID),Slippage*pipMultiplier,lsStop,lsTake,ExpertName,MAGIC,0,clOpenSell); 
     else
     {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(sStopLoss),MarketInfo(s_symbol,MODE_BID),Slippage*pipMultiplier,0,0,ExpertName,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Bid: ",MarketInfo(s_symbol,MODE_BID)," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
          }
     }
   }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double cl.fasttrendNow = iCustom(s_symbol,0,"Heiken_Ashi_Smoothed_v1",FastMaPeriod,FastMaMetod,FastStep,FastBetterFormula,4,haBar);
   double cl.fasttrendPre = iCustom(s_symbol,0,"Heiken_Ashi_Smoothed_v1",FastMaPeriod,FastMaMetod,FastStep,FastBetterFormula,4,haBar+1);
   double cl.slowtrendNow = iCustom(s_symbol,0,"Heiken_Ashi_Smoothed_v1",SlowMaPeriod,SlowMaMetod,SlowStep,SlowBetterFormula,4,haBar);
   double cl.slowtrendPre = iCustom(s_symbol,0,"Heiken_Ashi_Smoothed_v1",SlowMaPeriod,SlowMaMetod,SlowStep,SlowBetterFormula,4,haBar+1);
     
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (cl.slowtrendNow<0 && cl.fasttrendNow<0 && cl.fasttrendPre>0)
        {
          bool buyClose = OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_BID),Slippage*pipMultiplier,clCloseBuy);
          if (buyClose == false)
          {
            int ErrorCode   = GetLastError();
            string ErrDesc  = ErrorDescription(ErrorCode);

            string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts  == true) Alert(ErrAlert);

            string ErrLog   = StringConcatenate("Bid: ",MarketInfo(s_symbol,MODE_BID)," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (cl.slowtrendNow>0 && cl.fasttrendNow>0 && cl.fasttrendPre<0)
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_ASK),Slippage*pipMultiplier,clCloseSell); 
          if (sellClose  == false)
          {
            ErrorCode = GetLastError();
            ErrDesc   = ErrorDescription(ErrorCode);

            ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts == true) Alert(ErrAlert);

            ErrLog   = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
   }
}

//
//
//
//
//

double LotsOptimized(double stopLoss)
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
      Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
      return(0);
   }
   if(AccountLeverage()<=0)
   {
      Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0 && stopLoss>0)
   {
      double pipMultiplier=1;
      int digit  = MarketInfo(s_symbol,MODE_DIGITS);
         if (digit==2 || digit==4) pipMultiplier = 1;
         if (digit==3 || digit==5) pipMultiplier = 10;
         if (digit==6)             pipMultiplier = 100;
         double _point = MarketInfo(s_symbol,MODE_POINT);
         lot = AccountFreeMargin()*(MaximumRisk/100.0)/(stopLoss*pipMultiplier*MarketInfo(s_symbol,MODE_TICKVALUE));
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
        if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
        if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
        //
        //
        //
        //
        //
      
        if(OrderProfit() > 0) break;
        if(OrderProfit() < 0) losses++;
        }
        if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{
   if (StringFind(s_symbol, "CADJPY") >= 0) return(9822221);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(9822222);
   
   if (StringFind(s_symbol, "XAUUSD") >= 0) return(5622231);
   if (StringFind(s_symbol, "XAGUSD") >= 0) return(562232);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(5622241);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(5622242);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(5622251);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(5622261);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(5622262);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(5622263);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(5622264);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(5622265);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(5622266);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(5622267);
   if (StringFind(s_symbol, "EURDKK") >= 0) return(5622268);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(5622271);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(5622272);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(5622273);
   if (StringFind(s_symbol, "GBPNZD") >= 0) return(5622274);
   if (StringFind(s_symbol, "GBPCAD") >= 0) return(5622275);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(5622281);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(5622282);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(5622283);
   if (StringFind(s_symbol, "USDDKK") >= 0) return(5622284);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(5622291);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(5622292);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(5622293);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(5622294);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(5622295);
   
return(ManualMagic);
}

//
//
//
//
//

bool CheckTradingTimes() 
{
	if (ArraySize(tradeHours) == 0) return (true);
     int time = TimeHour(TimeLocal()) * 60 + TimeMinute(TimeLocal());
   
	  int i = 0;
	  while (time >= tradeHours[i]) 
	  {	
		    if (i == ArraySize(tradeHours)) break;
		    i++;		
	  }
  	  if (i % 2 == 1) return (true);
return ( false );
}

//
//
//
//
//

bool initTradingHours() 
{
	 if (tradingHours == "")	
	 {
		ArrayResize(tradeHours,0);
		return (true);
	}
   
   //
   //
   //
   //
   //
   
	if (StringSubstr(tradingHours, 0, 1) == "-")                    {	tradingHours = StringConcatenate("+0,", tradingHours);	}
	if (StringSubstr(tradingHours,StringLen(tradingHours)-1)!= ",") {	tradingHours = StringConcatenate(tradingHours,",");      }
	
	string lastPrefix = "-";
	int i = StringFind(tradingHours, ",");
	
	while (i != -1) 
	{

		int size      = ArraySize(tradeHours); ArrayResize(tradeHours,size + 1);
		string part   = StringSubstr(tradingHours, 0, i);
		string prefix = StringSubstr (part, 0, 1);
		if (prefix != "+" && prefix != "-") 
		{
			Print("ERROR IN TRADINGHOURS INPUT (NO START OR CLOSE FOUND), ASSUME 24HOUR TRADING.");
			ArrayResize (tradeHours, 0);
			return (true);
		}

		if ((prefix == "+" && lastPrefix == "+") || (prefix == "-" && lastPrefix == "-"))	
		{
			Print("ERROR IN TRADINGHOURS INPUT (START OR CLOSE IN WRONG ORDER), ASSUME 24HOUR TRADING.");
			ArrayResize (tradeHours, 0);
			return (true);
		}
		
		lastPrefix  = prefix;
		part        = StringSubstr(part, 1);
		double time = StrToDouble(part);
		int hour    = MathFloor(time);
		int minutes = MathRound((time - hour) * 100);
		tradeHours[size] = 60 * hour + minutes;
		tradingHours     = StringSubstr(tradingHours, i + 1);
		i = StringFind(tradingHours, ",");
	}
return (true);
}

//
//
//
//
//

double TimeZoneLocal()
{     
      //
      //
      //
      //
      //

	   switch(GetTimeZoneInformation(TZInfoArray))
	   {
	        case TIME_ZONE_ID_UNKNOWN: 
	        Print("Error obtaining PC timezone from GetTimeZoneInformation in kernel32.dll. Returning 0");
		     return(0);

	        case TIME_ZONE_ID_STANDARD:
		     return(TZInfoArray[0]/(-60.0));
	
	        case TIME_ZONE_ID_DAYLIGHT:
		     return((TZInfoArray[0]+TZInfoArray[42])/(-60.0));
		
 	        default:
		     Print("Unkown return value from GetTimeZoneInformation in kernel32.dll. Returning 0");
		     return(0);
	   }
}

// 
//
//
//
//

double TimeZoneServer()
{
	int ServerToLocalDiffMinutes = (TimeCurrent()-TimeLocal())/60;
	int nHalfHourDiff            = MathRound(ServerToLocalDiffMinutes/30.0);
	
	//
	//
	//
	//
	//
	
	ServerToLocalDiffMinutes = nHalfHourDiff*30;
	
return(TimeZoneLocal() + ServerToLocalDiffMinutes/60.0);
}

// 
//
//
//
//

datetime TimeGMT()
{

	    datetime dtGmtFromLocal  = TimeLocal()   - TimeZoneLocal() *3600;
	    datetime dtGmtFromServer = TimeCurrent() - TimeZoneServer()*3600;

       if (dtGmtFromLocal > dtGmtFromServer + 300)
	         { return(dtGmtFromLocal); }
	    else { return(dtGmtFromServer);}	
}

//
//
//
//
//

void ChartComment()
{
   RefreshRates();
   if (IsTesting() && !IsVisualMode()) return;
   if (IsTesting()) return;
   
   string symbol   = Symbol(); if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
  	double modifier = 1;
  	int    digits   = MarketInfo(symbol,MODE_DIGITS);
   if (digits==3 || digits==5) modifier = 10.0;
   
   //
  	//
  	//
  	//
  	//
   
   if(MarketInfo(symbol,MODE_SWAPLONG) > 0)                                string    swap="longs,";
                                                                           else      swap="shorts.";
   if(MarketInfo(symbol,MODE_SWAPLONG) < 0 && MarketInfo(symbol,MODE_SWAPSHORT) < 0) swap="your broker. ";
   
   //
   //
   //
   //
   //
   
   string strLocal  = TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	string strServer = TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	string strGMT    = TimeToStr(TimeGMT(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	
	
	string strLocalTimeZone;
	if (TimeZoneLocal() > 0)   strLocalTimeZone  = StringConcatenate("Local timezone: GMT plus  ", TimeZoneLocal()," hours");
	if (TimeZoneLocal() == 0)  strLocalTimeZone  = "Local timezone: GMT";
	if (TimeZoneLocal() < 0)   strLocalTimeZone  = StringConcatenate("Local timezone: GMT minus ",-TimeZoneLocal()," hours");
	
	string strServerTimeZone;
	if (TimeZoneServer() > 0)  strServerTimeZone = StringConcatenate("Server timezone: GMT plus  ", TimeZoneServer()," hours");
	if (TimeZoneServer() == 0) strServerTimeZone = "Server timezone: GMT";
  	if (TimeZoneServer() < 0)  strServerTimeZone = StringConcatenate("Server timezone: GMT minus ",-TimeZoneServer()," hours");
   
   //
   //
   //
   //
   //
   
   string sComment   = "";
   string sp         = "------------------------------------------------------------\n";
   string NL         = "\n";
       
   sComment = sp;
   sComment = sComment+ "Expert Name: "+ExpertName+NL;
   sComment = sComment+ "EA Version: "+Version+NL;
   sComment = sComment+ sp;
   sComment = sComment+ "Market Analysis" + NL;
   sComment = sComment+ "Swap favors " + swap + NL; 
   sComment = sComment+ "Swap Long      = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPLONG),2) + NL; 
   sComment = sComment+ "Swap Short     = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPSHORT),2) + NL; 
   sComment = sComment+ "Current Spread = " + DoubleToStr(MarketInfo(symbol,MODE_SPREAD)/ modifier,2) + NL; 
   if (SpreadProtection)
   {
     if (DontContinue==1)
         sComment = sComment+ "Spread Protection enabled and Spread unacceptable " + NL;
   else  sComment = sComment+ "Spread Protection enabled and Spread in normal range" + NL;
   }
   if (!SpreadProtection)
   sComment = sComment+ "Spread Protection Disabled " + NL;              
   sComment = sComment+ sp; 
   sComment = sComment+ "Time Information" + NL;
   sComment = sComment+ strLocalTimeZone  + NL;
   sComment = sComment+ strServerTimeZone + NL;
   sComment = sComment+ "PC Local Time = " +strLocal+ NL;
   sComment = sComment+ "Broker server time =  " +strServer+ NL;
   sComment = sComment+ "GMT time =  " +strGMT+ NL;
   if (tradingHoursDisplay != "") 
   sComment = sComment+ "Trading hours:" + tradingHoursDisplay + NL;
   else 
   sComment = sComment+ "24 hour trading!" + NL;
   sComment = sComment+ sp;
   sComment = sComment+ "Have a great trading day" + NL;
   sComment = sComment+ sp; 
   
Comment(sComment);
}





